
// 詳細表示画面
class StatusView {

    constructor(selector) {
        this.container = $(selector);
        this.question_key = null;
    }

    // 問題詳細画面を表示
    show_question(question_key = null){
        var _this = this;
        if(question_key != null){
            this.question_key = question_key;
        }

        $.ajax({
            type: 'GET',
            dataType: 'html',
            url: '/template/question/' + _this.question_key
        }).done((d) => {
            _this.container.empty();
            _this.container.html(d);

            _this.container.find('.start-button').click(()=>{
                _this.start_solver();
            });
        });
    }

    // 問題を解くのをスタート
    start_solver(){
        var _this = this;
        
        $.ajax({
            type: "POST",
            dataType: "json",
            url: "/api/question/solve",
            data: JSON.stringify({
                "question": _this.question_key
            }),
            contentType: 'application/json'
        }).done((d) => {
            // TODO: タイムアウトになる時間まで，モーダル表示させる
            console.log(d);
            _this.container.find('#solver-processing-modal').modal('show');
        });
    }
    
    // システム詳細画面を表示
    show_system(){
        var _this = this;

        $.ajax({
            type: "GET",
            dataType: "html",
            url: "/template/system-summary"
        }).done((d) => {
            _this.container.empty();
            _this.container.html(d);

            var button_action_with_ajax = function($obj, url){
                $obj.prop("disabled", "disabled");
                $.ajax({
                    type: "GET",
                    url: url,
                    dataType: "json",
                }).done((data)=>{
                    $obj.prop("disabled", false);
                    alert(data['message']);
                });
            };

            $("#adccli-login-button").click(function(){
                button_action_with_ajax($(this), "/adccli-login");
            });
            $("#adccli-logout-button").click(function(){
                button_action_with_ajax($(this), "/adccli-logout");
            });
            $("#adccli-get-all-q").click(function(){
                button_action_with_ajax($(this), "/adccli-get-all-q");
            });

            $.ajax({
                type: "GET",
                url: "/adccli-whoami",
                dataType: "json",
            }).done((data)=>{
                if(data['status'])
                    $("#adccli-status").text("ログイン中");
                else
                    $("#adccli-status").text("ログアウト");
            });

        });
    }
}

$(function(){

    const status_view = new StatusView('#status-container');

    var refresh_questions = function(){
        $.ajax({
            type: "GET",
            dataType: "html",
            url: "/template/questions"
        }).done((d) => {
            $("#question-list-container").empty();
            $("#question-list-container").html(d);

            $(".question-row td").click(function(){
                var $tr = $(this).parent("tr.question-row");
                $(".question-row").removeClass("q-selected");
                $tr.addClass("q-selected");
                var qname = $tr.data("qname");
                // show_question_status(qname);
                location.hash = "#" + qname;
                return false;
            });

            var hash = location.hash.replace("#", "");
            if(hash != ""){
                $(".question-row[data-qname='" + hash + "']").addClass("q-selected");
            }
        });
    }

    $(window).on('hashchange', function(){
        var hash = location.hash.replace("#", "");
        if(hash == ""){
            status_view.show_system();
        }else{
            status_view.show_question(hash);
        }
    }).trigger('hashchange');

    refresh_questions();

});

